//: C09:Duplicate.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Ukazuje duplikování podobjektů.
#include <iostream>
using namespace std;

class Nejvyssi {
  int x;
public:
  Nejvyssi(int n) { x = n; }
};

class Leva : public Nejvyssi {
  int y;
public:
  Leva(int m, int n) : Nejvyssi(m) { y = n; }
};

class Prava : public Nejvyssi {
  int z;
public:
  Prava(int m, int n) : Nejvyssi(m) { z = n; }
};

class Nejnizsi : public Leva, public Prava {
  int w;
public:
  Nejnizsi(int i, int j, int k, int m)
  : Leva(i, k), Prava(j, k) { w = m; }
};

int main() {
  Nejnizsi b(1, 2, 3, 4);
  cout << sizeof b << endl; // 20
} ///:~
